/*
Copyright (c) 2010, Michael Kazhdan
All rights reserved.

Redistribution and use in source and binary forms, with or without modification,
are permitted provided that the following conditions are met:

Redistributions of source code must retain the above copyright notice, this list of
conditions and the following disclaimer. Redistributions in binary form must reproduce
the above copyright notice, this list of conditions and the following disclaimer
in the documentation and/or other materials provided with the distribution. 

Neither the name of the Johns Hopkins University nor the names of its contributors
may be used to endorse or promote products derived from this software without specific
prior written permission. 

THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND ANY
EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO THE IMPLIED WARRANTIES 
OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT
SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT,
INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED
TO, PROCUREMENT OF SUBSTITUTE  GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR
BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN
CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN
ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH
DAMAGE.
*/
#ifndef JPEG_STREAM_INCLUDED
#define JPEG_STREAM_INCLUDED
#include <stdio.h>
#include <stdlib.h>
#include <setjmp.h>
#include <windows.h>

#include "JPEG/jpeglib.h"
#include "JPEG/jerror.h"
#include "JPEG/jinclude.h"

#include <Util/MultiStreamIO.h>

typedef struct
{
	struct jpeg_destination_mgr pub;	/* public fields */
	VariableIOClientStream* outStream;	/* target stream */
	JOCTET * buffer;					/* start of buffer */
} misha_destination_mgr;
typedef misha_destination_mgr * misha_dest_ptr;

typedef struct
{
	struct jpeg_source_mgr pub;			/* public fields */
	VariableIOClientStream* inStream; 	/* source stream */
	JOCTET * buffer;					/* start of buffer */
	boolean start_of_file;				/* have we gotten any data yet? */
} misha_source_mgr;

typedef misha_source_mgr * misha_src_ptr;


////////////////////////////////////////////////////////////////////
// Code adapted from example.c provided with libjpeg distribution //
////////////////////////////////////////////////////////////////////

struct my_error_mgr
{
	struct jpeg_error_mgr pub;    // "public" fields
	jmp_buf setjmp_buffer;        // for return to caller
};
typedef struct my_error_mgr * my_error_ptr;


struct JPEGReadInfo
{
	VariableIOClientStream* inStream;
	struct jpeg_decompress_struct cInfo;
	struct my_error_mgr	jErr;
};
struct JPEGWriteInfo
{
	VariableIOClientStream* outStream;
	struct jpeg_compress_struct cInfo;
	struct jpeg_error_mgr jErr;
};
#endif // JPEG_STREAM_INCLUDED
